=encoding utf8

=head1 NAME

Mail::Message::Field::Date - message header field with uris

=head1 INHERITANCE

 Mail::Message::Field::Date
   is a Mail::Message::Field::Structured
   is a Mail::Message::Field::Full
   is a Mail::Message::Field
   is a Mail::Reporter

=head1 SYNOPSIS

  my $f = Mail::Message::Field->new(Date => time);
  my $f = Mail::Message::Field::Date->new(Date => time);
  my $date = $f->date;    # cleaned-up and validated
  my $time = $date->time; # converted to POSIX time

=head1 DESCRIPTION

Dates are a little more tricky than it should be: the formatting permits
a few constructs more than other RFCs use for timestamps.  For instance,
a small subset of timezone abbreviations are permitted.

The studied date field will reformat the content into a standard
form.

Extends L<"DESCRIPTION" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"DESCRIPTION">.

=head1 OVERLOADED

Extends L<"OVERLOADED" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"OVERLOADED">.

=over 4

=item overload: B<""> stringification

Inherited, see L<Mail::Message::Field::Full/"OVERLOADED">

=item overload: B<'""'> stringification

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<'0+'> numification

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<'<=>'> numeric comparison

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<bool> boolean

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=item overload: B<cmp> string comparison

Inherited, see L<Mail::Message::Field/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Constructors">.

=over 4

=item $obj-E<gt>B<clone>()

Inherited, see L<Mail::Message::Field/"Constructors">

=item $class-E<gt>B<from>($field, %options)

Inherited, see L<Mail::Message::Field::Full/"Constructors">

=item $class-E<gt>B<new>($data)

Inherited, see L<Mail::Message::Field::Structured/"METHODS">

 -Option    --Defined in                      --Default
  attributes  Mail::Message::Field::Structured  <ignored>
  charset     Mail::Message::Field::Full        undef
  datum       Mail::Message::Field::Structured  undef
  encoding    Mail::Message::Field::Full        'q'
  force       Mail::Message::Field::Full        false
  language    Mail::Message::Field::Full        undef

=over 2

=item attributes => \@attributes|\%attributes

=item charset => $charset

=item datum => $date

=item encoding => 'q'|'Q'|'b'|'B'

=item force => BOOLEAN

=item language => $language

=back

» example: 

  my $mmfd = 'Mail::Message::Field::Date';
  my $f = $mmfd->new(Date => time);

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Attributes">.

=over 4

=item $obj-E<gt>B<Name>()

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<body>()

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<folded>()

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<foldedBody>( [$body] )

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<unfoldedBody>( [$body, [$wrap]] )

Inherited, see L<Mail::Message::Field/"Attributes">

=item $obj-E<gt>B<wellformedName>( [STRING] )

Inherited, see L<Mail::Message::Field/"Attributes">

=back

=head2 The field

Extends L<"The field" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"The field">.

=over 4

=item $any-E<gt>B<isStructured>( [$name] )

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<length>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<nrLines>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<print>( [$fh] )

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<size>()

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<string>( [$wrap] )

Inherited, see L<Mail::Message::Field/"The field">

=item $obj-E<gt>B<toDisclose>()

Inherited, see L<Mail::Message::Field/"The field">

=back

=head2 Access to the body

Extends L<"Access to the body" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Access to the body">.

=over 4

=item $obj-E<gt>B<decodedBody>(%options)

Inherited, see L<Mail::Message::Field::Full/"Access to the body">

=back

=head2 Access to the content

Extends L<"Access to the content" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Access to the content">.

=over 4

=item $obj-E<gt>B<addAttribute>(...)

Attributes are not supported for date fields.

=item $obj-E<gt>B<addresses>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<attrPairs>()

Inherited, see L<Mail::Message::Field::Structured/"Access to the content">

=item $obj-E<gt>B<attribute>( $object|<STRING, %options>|<$name,$value,%options> )

Inherited, see L<Mail::Message::Field::Structured/"Access to the content">

=item $obj-E<gt>B<attributes>()

Inherited, see L<Mail::Message::Field::Structured/"Access to the content">

=item $obj-E<gt>B<beautify>()

Inherited, see L<Mail::Message::Field::Full/"Access to the content">

=item $obj-E<gt>B<comment>( [STRING] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $any-E<gt>B<createComment>(STRING, %options)

Inherited, see L<Mail::Message::Field::Full/"Access to the content">

=item $any-E<gt>B<createPhrase>(STRING, %options)

Inherited, see L<Mail::Message::Field::Full/"Access to the content">

=item $obj-E<gt>B<date>()

The validated and standardized date representation for this field.
When the body of this field is not recognized, then this will return
C<undef>.

=item $any-E<gt>B<dateToTimestamp>(STRING)

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $any-E<gt>B<stripCFWS>( [STRING] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<study>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<time>()

Convert date into a timestamp, as produced with POSIX::time().

=item $any-E<gt>B<toDate>( [$time] )

Inherited, see L<Mail::Message::Field/"Access to the content">

=item $obj-E<gt>B<toInt>()

Inherited, see L<Mail::Message::Field/"Access to the content">

=back

=head2 Internals

Extends L<"Internals" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Internals">.

=over 4

=item $any-E<gt>B<decode>(STRING, %options)

Inherited, see L<Mail::Message::Field::Full/"Internals">

=item $obj-E<gt>B<encode>(STRING, %options)

Inherited, see L<Mail::Message::Field::Full/"Internals">

=back

=head2 Parsing

Extends L<"Parsing" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Parsing">.

=over 4

=item $obj-E<gt>B<consume>( $line | <$name,<$body|$objects>> )

Inherited, see L<Mail::Message::Field/"Parsing">

=item $any-E<gt>B<consumeComment>(STRING)

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $obj-E<gt>B<consumeDotAtom>(STRING)

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $any-E<gt>B<consumePhrase>(STRING)

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $obj-E<gt>B<datum>( [$value] )

Inherited, see L<Mail::Message::Field::Structured/"Parsing">

=item $obj-E<gt>B<defaultWrapLength>( [$length] )

Inherited, see L<Mail::Message::Field/"Parsing">

=item $any-E<gt>B<fold>( $name, $body, [$maxchars] )

Inherited, see L<Mail::Message::Field/"Parsing">

=item $obj-E<gt>B<parse>(STRING)

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $obj-E<gt>B<produceBody>()

Inherited, see L<Mail::Message::Field::Full/"Parsing">

=item $obj-E<gt>B<setWrapLength>( [$length] )

Inherited, see L<Mail::Message::Field/"Parsing">

=item $obj-E<gt>B<stringifyData>(STRING|ARRAY|$objects)

Inherited, see L<Mail::Message::Field/"Parsing">

=item $obj-E<gt>B<unfold>(STRING)

Inherited, see L<Mail::Message::Field/"Parsing">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DETAILS

Extends L<"DETAILS" in Mail::Message::Field::Structured|Mail::Message::Field::Structured/"DETAILS">.

=head1 DIAGNOSTICS

=over 4

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Warning: field content is not numerical: $content

The numeric value of a field is requested (for instance the C<Lines> or
C<Content-Length> fields should be numerical), however the data contains
weird characters.
Cast by C<toInt()>

=item Error: field name too long (max $count), in '$name'.

It is not specified in the RFCs how long a field name can be, but
at least it should be a few characters shorter than the line wrap.
Cast by C<fold()>

=item Warning: illegal character in charset '$name'.

The field is created with an utf8 string which only contains data from the
specified character set.  However, that character set can never be a valid
name because it contains characters which are not permitted.
Cast by C<encode()>

=item Warning: illegal character in field name $name.

A new field is being created which does contain characters not permitted
by the RFCs.  Using this field in messages may break other e-mail clients
or transfer agents, and therefore mutulate or extinguish your message.
Cast by C<consume()>

=item Warning: illegal character in language '$name'.

The field is created with data which is specified to be in a certain language,
however, the name of the language cannot be valid: it contains characters
which are not permitted by the RFCs.
Cast by C<encode()>

=item Warning: illegal encoding '$name', using 'q'.

The RFCs only permit base64 (C<b > or C<B >) or quoted-printable
(C<q> or C<Q>) encoding.  Other than these four options are illegal.
Cast by C<encode()>

=item Error: no attributes for date fields.

It is not possible to add attributes to date fields: it is not permitted
by the RFCs.
Cast by C<addAttribute()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.05,
built on April 10, 2026. Website: F<http://perl.overmeer.net/mailbox/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

